Loading...
Searching...
No Matches
Halide::Internal::IRMatcher::RampOp< A, B, C > Struct Template Reference

`#include <IRMatch.h>`

## Classes

struct | pattern_tag

## Public Member Functions

template<uint32_t bound>
HALIDE_ALWAYS_INLINE bool | match (const BaseExprNode &e, MatcherState &state) const noexcept
template<uint32_t bound, typename A2, typename B2, typename C2>
HALIDE_ALWAYS_INLINE bool | match (const RampOp< A2, B2, C2 > &op, MatcherState &state) const noexcept
HALIDE_ALWAYS_INLINE Expr | make (MatcherState &state, halide_type_t type_hint) const

## Public Attributes

A | a
B | b
C | lanes

## Static Public Attributes

static constexpr uint32_t | binds = bindings<A>::mask | bindings<B>::mask | bindings<C>::mask
static constexpr IRNodeType | min_node_type = IRNodeType::Ramp
static constexpr IRNodeType | max_node_type = IRNodeType::Ramp
static constexpr bool | canonical = A::canonical && B::canonical && C::canonical
static constexpr bool | foldable = false

## Detailed Description

template<typename A, typename B, typename C>
struct Halide::Internal::IRMatcher::RampOp< A, B, C >

Definition at line 1807 of file IRMatch.h.

## Member Function Documentation

## match() [1/2]

template<typename A, typename B, typename C>
template<uint32_t bound>

HALIDE_ALWAYS_INLINE bool Halide::Internal::IRMatcher::RampOp< A, B, C >::match | ( | const BaseExprNode & | e,
|  | MatcherState & | state ) const

inline noexcept

Definition at line 1821 of file IRMatch.h.

References Halide::Internal::Ramp::_node_type, a, b, Halide::Internal::Ramp::base, Halide::Expr::get(), HALIDE_ALWAYS_INLINE, lanes, Halide::Internal::Ramp::lanes, Halide::Internal::IRMatcher::bindings< T >::mask, match(), and Halide::Internal::Ramp::stride.

Referenced by match(), and match().

## match() [2/2]

template<typename A, typename B, typename C>
template<uint32_t bound, typename A2, typename B2, typename C2>

HALIDE_ALWAYS_INLINE bool Halide::Internal::IRMatcher::RampOp< A, B, C >::match | ( | const RampOp< A2, B2, C2 > & | op,
|  | MatcherState & | state ) const

inline noexcept

Definition at line 1836 of file IRMatch.h.

References a, b, HALIDE_ALWAYS_INLINE, lanes, Halide::Internal::IRMatcher::bindings< T >::mask, match(), and Halide::Internal::IRMatcher::unwrap().

## make()

template<typename A, typename B, typename C>

HALIDE_ALWAYS_INLINE Expr Halide::Internal::IRMatcher::RampOp< A, B, C >::make | ( | MatcherState & | state,
|  | halide_type_t | type_hint ) const

inline

Definition at line 1843 of file IRMatch.h.

References a, b, halide_scalar_value_t::i64, lanes, halide_type_t::lanes, Halide::Internal::Ramp::make(), Halide::Expr::type(), and halide_scalar_value_t::u.

## Member Data Documentation

## a

template<typename A, typename B, typename C>

A Halide::Internal::IRMatcher::RampOp< A, B, C >::a

Definition at line 1809 of file IRMatch.h.

Referenced by make(), match(), match(), and Halide::Internal::IRMatcher::operator<<().

## b

template<typename A, typename B, typename C>

B Halide::Internal::IRMatcher::RampOp< A, B, C >::b

Definition at line 1810 of file IRMatch.h.

Referenced by make(), match(), match(), and Halide::Internal::IRMatcher::operator<<().

## lanes

template<typename A, typename B, typename C>

C Halide::Internal::IRMatcher::RampOp< A, B, C >::lanes

Definition at line 1811 of file IRMatch.h.

Referenced by make(), match(), match(), and Halide::Internal::IRMatcher::operator<<().

## binds

template<typename A, typename B, typename C>

uint32_t Halide::Internal::IRMatcher::RampOp< A, B, C >::binds = bindings<A>::mask | bindings<B>::mask | bindings<C>::mask

static constexpr

Definition at line 1813 of file IRMatch.h.

## min_node_type

template<typename A, typename B, typename C>

IRNodeType Halide::Internal::IRMatcher::RampOp< A, B, C >::min_node_type = IRNodeType::Ramp

static constexpr

Definition at line 1815 of file IRMatch.h.

## max_node_type

template<typename A, typename B, typename C>

IRNodeType Halide::Internal::IRMatcher::RampOp< A, B, C >::max_node_type = IRNodeType::Ramp

static constexpr

Definition at line 1816 of file IRMatch.h.

## canonical

template<typename A, typename B, typename C>

bool Halide::Internal::IRMatcher::RampOp< A, B, C >::canonical = A::canonical && B::canonical && C::canonical

static constexpr

Definition at line 1818 of file IRMatch.h.

## foldable

template<typename A, typename B, typename C>

bool Halide::Internal::IRMatcher::RampOp< A, B, C >::foldable = false

static constexpr

Definition at line 1855 of file IRMatch.h.

The documentation for this struct was generated from the following file:

- src/IRMatch.h